package geo;

import java.awt.Graphics;

/**
 * Courbe d'une fonction
 */
public class CourbeFonction extends ObjetGeo {
	Fonction f;

/** Définit la courbe à partir d'une fonction. */
	public CourbeFonction (Fonction f) {
		super();
		this.f = f;
	}


/** Trace la courbe de la fonction. */
	public void trace (String nom, Repere R, Graphics g) {
		int Xp = -1, Yp = -1;
		int RXMAXs2 = R.XMAX / 2;
		for (int X = 0; X < R.XMAX; X++) {
			double x = R.x (X);
			int Y = (f.defini(x)) ? R.Y (f.Image (x)) : Integer.MIN_VALUE;
			if ((Yp >= 0) && (Yp < R.YMAX) && Y != Integer.MIN_VALUE) {
				g.drawLine (Xp, Yp, X, Y);
				if ((X > RXMAXs2) && (nom != null) && (nom.length() != 0)) {
					g.drawString (nom, X + 3, Y - 3);
					RXMAXs2 = Integer.MAX_VALUE;
				}
			}
			Xp = X;
			Yp = Y;
		}
	}

}
