package geo;

import java.awt.Graphics;
import geo.*;

/**
 * Demi-droite [AB)
 */
public class DemiDroite extends ObjetGeo {
/** Abscisse de A.*/
	public double Ax;
/** Ordonnée de A.*/
	public double Ay;
/** Abscisse de B.*/
	public double Bx;
/** Ordonnée de B.*/
	public double By;

/** Construit une demi-droite non définie.*/
	public DemiDroite() {
		super();
	}

/** Construit la demi-droite [AB) à partir des points A et B.*/
	public DemiDroite (Pt A, Pt B) {
		MAJ (A, B);
	}

/** Construit une demi-droite à partir de l'extrémité A et du vecteur directeur u.*/
	public DemiDroite (Pt A, Vecteur u) {
		MAJ (A, u);
	}

/** Construit une demi-droite à partir de l'extrémité A, du vecteur directeur u. */
	public DemiDroite (Pt A, Vecteur u, String nom, Repere R) {
		MAJ (A, u);
	}

/** Construit la demi-droite [AB) à partir des coordonnées de A et B. */
	public DemiDroite (double Ax, double Ay, double Bx, double By) {
		this.Ax = Ax;
		this.Ay = Ay;
		this.Bx = Bx;
		this.By = By;
		defini = ((Ax != Bx) || (Ay != By));
	}

/** Trace la demi-droite courante.*/
	public void trace (String nom, Repere R, Graphics g) {
		int X1, Y1, X2, Y2;
		X1 = Y1 = X2 = Y2 = 0;
		double a = By - Ay;
		double b = Ax - Bx;
		double c = Ay * Bx - Ax * By;
		if (defini) {
			if (Math.abs (b) >= Math.abs (a))
				if (b < 0.0) {
					X1 = R.X (Ax);
					Y1 = R.Y (Ay);
					X2 = R.XMAX;
					Y2 = R.Y (-(a * R.x (X2) + c) / b);
				} else {
					X1 = 0;
					Y1 = R.Y (-(a * R.x (X1) + c) / b);
					X2 = R.X (Ax); Y2 = R.Y (Ay);
				} else if (a > 0.0) {
					Y1 = 0;
					X1 = R.X (-(b * R.y (0) + c) / a);
					X2 = R.X (Ax); Y2 = R.Y (Ay);
				} else {
					X1 = R.X (Ax); Y1 = R.Y (Ay);
					Y2 = R.YMAX;
					X2 = R.X (-(b * R.y (Y2) + c) / a);
				}
				g.drawLine (X1, Y1, X2, Y2);
				if (nom != null && nom.length() != 0)
					g.drawString (nom, (X1 + X2) / 2 + 3, (Y1 + Y2) / 2 - 3);
		}
	}

/** Met à jour le segment courant à partir des points A et B.*/
	public void MAJ (Pt A, Pt B) {
		defini = A.defini && B.defini && ((A.x != B.x) || (A.y != B.y));
		Ax = A.x;
		Ay = A.y;
		Bx = B.x;
		By = B.y;
	}

/** Met à jour le segment courant à partir du point A et du vecteur directeur u.*/
	public void MAJ (Pt A, Vecteur u) {
		defini = ((u.x != 0.0) || (u.y != 0.0));
		Ax = A.x;
		Ay = A.y;
		Bx = A.x + u.x;
		By = A.y + u.y;
	}

/** toString */
	public String toString() {
		return "DemiDroite : [AB) A(" + Ax + ", " + Ay + ") B(" + Bx + ", " + By + ") defini = " +defini;
	}

}
