package geo;

import java.awt.Graphics;
import java.awt.Polygon;

/**
 * Polygone
 */
public class Polygone extends ObjetGeo {

/** Abscisses des points du polygone. */
	public double[] xi;

/** Ordonnées des points du polygone. */
	public double[] yi;

/** Construit un polygone non défini */
	public Polygone () {
		super();
	}

/** Construit le polygone passant par les points Ai. */
	public Polygone (Pt[] Ai) {
		super();
		MAJ (Ai);
	}

/**
 * Construit un polygone nommé passant par les points de coordonnées (xi, yi).
 * Si xi et yi n'ont pas la même dimension c'est le minimum qui est utilisé&nbsp;; les valeurs restantes sont ignorées.
 */
	public Polygone (double xi[], double yi[]) {
		super();
		MAJ (xi, yi);
	}

/** Construit le polygone nommé passant par les points Ai.
 * On précise ici si on veut qu'il soit rempli ou en mode fil de fer à l'affichage.
 */
	public Polygone (Pt Ai[], boolean type) {
		super();
		MAJ (Ai);
	}

/** Met à jour en précisant les points Ai */
	public void MAJ (Pt[] Ai) {
		int n = Ai.length;
		defini = true;
		for (int i = 0; (i < n) && defini; i++)
			defini = defini && Ai[i].defini;
		if (defini) {
			if ((xi == null) || (n != xi.length)) {
				xi = new double [n];
				yi = new double [n];
			}
			for (int i = 0; i < n; i++) {
				xi [i] = Ai[i].x;
				yi [i] = Ai[i].y;
			}
		}
	}

/**
 * Met à jour le polygone en précisant les points de coordonnées (xi, yi).
 * Si xi et yi n'ont pas la même dimension c'est le minimum qui est utilisé&nbsp;; les valeurs restantes sont ignorées.
 */
	public void MAJ (double xi[], double yi[]) {
		int n = Math.min (xi.length, yi.length);
		defini = true;
		if ((this.xi == null) || (n != xi.length)) {
			this.xi = new double [n];
			this.yi = new double [n];
		}
		for (int i = 0; i < n; i++) {
			this.xi [i] = xi [i];
			this.yi [i] = yi [i];
		}
	}

/** Retourne le nombre de points du polygone courant */
	public int nombre_points() {
		return Math.min (xi.length, yi.length);
	}

/**
 * Trace le polygone en précisant le type de tracé.
 * "true" pour un remplissage de la figure, "false" pour le dessin du bord uniquement.
 */
	public void trace (boolean type, String nom, Repere R, Graphics g) {
		if (defini) {
			Polygon p = new Polygon();
			int n = xi.length;
			for (int i = 0; i < n; i++)
				p.addPoint (R.X(xi[i]), R.Y(yi[i]));
			p.addPoint (R.X(xi[0]), R.Y(yi[0]));
			if (type)
				g.fillPolygon (p);
			else
				g.drawPolygon (p);
			if ((defini) && (nom != null) && (nom.length() != 0) && (p.npoints > 0))
				g.drawString (nom, p.xpoints [0] + 2 , p.ypoints [0] + 2);
		}
	}

/** toString */
	public String toString() {
		int n = Math.min (xi.length, yi.length);
		String s = "Polygone : n = " + n;
		for (int i = 0; i < n; i++)
			s += " (" + xi[i] + ", " + yi[i] + ")";
		s += " defini = " + defini;
		return s;
	}

}
